import sys

def get_input():
    s = sys.stdin.readline()
    x, y = map(int, s.split())
    return x, y

def get_dist(t1, t2):
    # print(t1, t2, max(abs(t2[1] - t1[1]), abs(t2[0] - t1[0])))
    return max(abs(t2[1] - t1[1]), abs(t2[0] - t1[0]))

if __name__ == "__main__":
    n, m = get_input()
    sec = {}
    for i in range(n):
        x, y = get_input()
        if x not in sec:
            sec[x] = []
        sec[x].append((x, y))

    for k in sec.keys():
        sec[k] = sorted(sec[k], key=lambda kv: kv[1])

    # print(sec)
    for i in range(m):
        x, y = get_input()
        ans = 5001
        for k, v in sec.items():
            # print(k, v)
            l = 0
            r = len(v)
            while (r - l) > 1:
                m = (l + r) // 2
                if v[m][1] > y:
                    r = m
                else:
                    l = m
            if (l == len(v) - 1):
                ans = min(ans, get_dist((x, y), v[l]))
            else:
                ans = min(ans, min(get_dist((x, y), v[l]), get_dist((x, y), v[l + 1])))

        print(ans)
    exit(0)


